# Method: updateIapSettings

- [HTTP request](https://docs.cloud.google.com/iap/docs/reference/rest/v1/TopLevel/updateIapSettings#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/iap/docs/reference/rest/v1/TopLevel/updateIapSettings#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/iap/docs/reference/rest/v1/TopLevel/updateIapSettings#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/iap/docs/reference/rest/v1/TopLevel/updateIapSettings#body.request_body)
- [Response body](https://docs.cloud.google.com/iap/docs/reference/rest/v1/TopLevel/updateIapSettings#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/iap/docs/reference/rest/v1/TopLevel/updateIapSettings#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/iap/docs/reference/rest/v1/TopLevel/updateIapSettings#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/iap/docs/reference/rest/v1/TopLevel/updateIapSettings#try-it)

Updates the IAP settings on a particular IAP protected resource. It replaces all fields unless the `updateMask` is set.

### HTTP request

`PATCH https://iap.googleapis.com/v1/{iapSettings.name=**}:iapSettings`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `iapSettings.name` | `string` Required. The resource name of the IAP protected resource. |

### Query parameters

| Parameters ||
|---|---|
| `updateMask` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#field-mask` format)`` The field mask specifying which IAP settings should be updated. If omitted, then all of the settings are updated. See <https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#fieldmask>. Note: All IAP reauth settings must always be set together, using the field mask: `iapSettings.accessSettings.reauthSettings`. This is a comma-separated list of fully qualified names of fields. Example: `"user.displayName,photo"`. |

### Request body

The request body contains an instance of `https://docs.cloud.google.com/iap/docs/reference/rest/v1/IapSettings`.

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/iap/docs/reference/rest/v1/IapSettings`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

Requires **one of** the following [IAM](https://cloud.google.com/iam/docs) permissions on the `name` resource, depending on the resource type:

- `iap.folders.updateSettings`
- `iap.organizations.updateSettings`
- `iap.projects.updateSettings`
- `iap.web.updateSettings`
- `iap.webServices.updateSettings`
- `iap.webServiceVersions.updateSettings`
- `iap.webTypes.updateSettings`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).